'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lr = require('@lezer/lr');
var language = require('@codemirror/language');
var highlight = require('@lezer/highlight');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const newline = 69, ignoredNewline = 70, Ident = 1, FnIdent = 2, DollarIdent = 3, LBracket = 12, RBracket = 13, LParen = 14, RParen = 15, Comma = 20, LBrace = 50, RBrace = 51;

class MyContext {
    constructor(parent, data) {
        this.parent = parent !== null && parent !== void 0 ? parent : this;
        this.data = data;
    }
    ignoreNewlines(value) {
        return new MyContext(this, Object.assign(Object.assign({}, this.data), { ignoreNewlines: value }));
    }
    justHadComma(value) {
        return new MyContext(this.parent, Object.assign(Object.assign({}, this.data), { justHadComma: value }));
    }
}
const startContext = new MyContext(null, { ignoreNewlines: false, justHadComma: false });
const context = new lr.ContextTracker({
    start: startContext,
    reduce(context, term, stack, input) {
        return context;
    },
    shift(context, term, stack, input) {
        context = context.justHadComma(term === Comma);
        if (term === LParen || term == LBracket) {
            return context.ignoreNewlines(true);
        }
        if (term === LBrace) {
            return context.ignoreNewlines(false);
        }
        if (term === RParen || term == RBrace || term == RBracket) {
            return context.parent;
        }
        return context;
    }
});
function code(x) {
    return x.charCodeAt(0);
}
const newlines = new lr.ExternalTokenizer((input, stack) => {
    let ctx = stack.context.data;
    if (input.next == code("\n")) {
        let ignore = ctx.ignoreNewlines || ctx.justHadComma;
        input.acceptToken(ignore ? ignoredNewline : newline, 1);
        return;
    }
}, { contextual: true });
const identifiers = new lr.ExternalTokenizer((input, stack) => {
    const a = code("a");
    const z = code("z");
    const A = code("A");
    const Z = code("Z");
    const u = code("_");
    const n0 = code("0");
    const n9 = code("9");
    const first = (n) => (a <= n && n <= z) || (A <= n && n <= Z) || (n == u);
    const rest = (n) => first(n) || (n0 <= n && n <= n9);
    let token = Ident;
    if (!first(input.peek(0))) {
        if (input.peek(0) != code("$")) {
            return;
        }
        token = DollarIdent;
    }
    let n = 1;
    while (rest(input.peek(n))) {
        n += 1;
    }
    if (input.peek(n) == code("(")) {
        token = FnIdent;
    }
    input.acceptToken(token, n);
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_Ident = {__proto__:null,and:72, else:74, false:76, if:78, in:80, let:82, match:84, meta:86, not:88, null:90, or:92, this:94, true:96};
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "+|Q`Q!ROOP}OPOOOOQ!Q'#Dj'#DjO`Q!RO'#DzOOQ!Q'#Cc'#CcO%eQ!RO'#CeO%lQ!RO'#CdO(zQaO'#DhO)SQaO'#DgOOQ`'#D|'#D|O)XQaO'#DzO)gQ!RO'#DzQOQaOOO%lQ!RO'#D|P*RO!bO'#CaPOOO)C?k)C?kOOQ!Q-E7h-E7hO*ZQaO,5:fO)gQ!RO,5:fO*iQ!RO,5:SOOQ!Q'#EO'#EOO*tQ!RO'#D_O+OOQO'#ERO+ZOSO'#EUO+cOWO'#EXOOQ!Q'#De'#DeOOQ!Q'#D}'#D}O.sQ!RO'#D}OOQ!Q'#Dk'#DkO1|Q!RO'#CfOOQ`,59O,59OOOQ!Q'#EQ'#EQO%lQ!RO,5:RO2uQ!RO'#DqO*ZQaO,5:fO)gQ!RO,5:fOOQ`,5:h,5:hPOOO'#Di'#DiP3VO!bO,58{POOO,58{,58{O3_QaO1G0QO)gQ!RO1G0QO3_QaO1G0QOOQ!Q'#Dp'#DpO3mQ!RO1G/nO3xQ!RO,59|O4PQ!RO,59|OOQ!Q,59y,59yO4WQaO,5:OOOOO'#Dm'#DmO4]OQO,5:mOOQ!Q,5:m,5:mOOOO'#Dn'#DnO4hOSO,5:pOOQ!Q,5:p,5:pOOOO'#Do'#DoO4pOWO,5:sOOQ!Q,5:s,5:sOOQ!Q'#Dl'#DlO4xQ!RO'#DcOOQ!Q'#Dc'#DcOOQ!Q,5:i,5:iOOQ!Q-E7i-E7iOOQ`1G/m1G/mOOQ`,5:],5:]OOQ`-E7o-E7oPOOO-E7g-E7gPOOO1G.g1G.gO5PQaO7+%lO5PQaO7+%lOOQ!Q-E7n-E7nO5_Q!RO1G/hOOQ!Q1G/h1G/hOOQ!Q1G/j1G/jOOOO-E7k-E7kOOQ!Q1G0X1G0XOOOO-E7l-E7lOOQ!Q1G0[1G0[OOOO-E7m-E7mOOQ!Q1G0_1G0_OOQ!Q-E7j-E7jOOQ!Q,59},59}O5fQaO<<IWOOQ!Q7+%S7+%S",
  stateData: "5w~O!jOS!hOSSOS!kPQ~OPTOmVOw]Oy]Oz]O{VO!PVO!gQO!oSO~O!k^O~OfcOPXXQXXRXXZXX[XX]XX^XX_XX`XXaXXbXXcXXdXXeXXe![XfXXgXXhXXiXXjXXkXXlXXmXXnXXoXXpXXqXXrXXsXXtXXuXXvXXwXXxXXyXXzXX{XX|XX}XX!OXX!PXX!QXX!SXX!gXX!oXX!sXX!vXX!yXX!|XX!TXX~O!fXX~P!SOPjOQjORjOZjO[dO]dO^dO_dO`dOadObdOcdOddOedOfdOgdOhdOidOjdOkdOldOmdOndOodOpdOqdOrdOsdOtoOuoOvoOwoOxoOyoOzoO{oO|oO}oO!OoO!PoO!QoO!SeO!sdO!vfO!ygO!|hO!fYP!gYP!oYP!TYP~OfcOe![X~OepO~O!gqO!oSO!f!nX!T!nX~OPTOmVOw]Oy]Oz]O{VO!PVO!gQO~O!luO!mwO~O!gqO!oSO!f!na!T!na~OP{Of{Oe![a~OP!OO!T!PO~PcO!Y!RO!v!TO!w!RO~O!v!WO!z!UO~O!}!XO#O!ZO~OPjOQjORjOZjO[dO]dO^dO_dO`dOadObdOcdOddOedOfdOgdOhdOidOjdOkdOldOmdOndOodOpdOqdOrdOsdOtoOuoOvoOwoOxoOyoOzoO{oO|oO}oO!OoO!PoO!QoO!SeO!g![O!oSO!sdO!vfO!ygO!|hO~O!T!^O~P+kOPjOQjORjOZjO[dO]dO^dO_dO`dOadObdOcdOddOedOfdOgdOhdOidOjdOkdOldOmdOndOodOpdOqdOrdOsdOtoOuoOvoOwoOxoOyoOzoO{oO|oO}oO!OoO!PoO!QoO!SeO!sdO!vfO!ygO!|hO~O!fYX!gYX!oYX!TYX~P.zOPTOmVOw]Oy]Oz]O{VO!PVO~O!f!eX!g!eX!o!eX!T!eX~P2^O!luO!m!eO~O!gqO!oSO!f!ni!T!ni~OP{Of{Oe![i~OP!iO~PcOh!jO~P!SO!T!kO~O!Y!RO!v!mO!w!RO~O!v!oO!z!UO~O!}!XO#O!qO~O!T!sO~P+kO!gqO!oSO!f!nq!T!nq~Oh!uO~P!SO!gqO!oSO!f!ny!T!ny~OSc~",
  goto: "'h!|PPPPP!}P#Q#h#s$OPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP$XPP$a$i$X$XP#h$l$w$}%a%i%o%u%{&R&XPPPPPPPP&kP&q'U$XP$X'`PP'`PP'`R_PSZOeSbR}`qYarxz!f!g!tT![k!]cXORZbeqsy}cUORZbeqsy}QnUQt]R!ap]jU]kmp!]]kU]kmp!]R!_kcWORZbeqsy}Qv^R!dvQROW`Rsy}QsZQybR}eUmU]pR!`mQ!]kR!r!]Q!SfR!l!SQ!VgR!n!VQ!YhR!p!YQ|cR!h|QrYQxaW!crx!g!tQ!gzR!t!fQ[OR!QeSYOeUaRZ}SzbsQ!bqR!fyWlU]mpT![k!]]iU]kmp!]",
  nodeNames: "⚠ Ident FnIdent DollarIdent LineComment BlockComment Pipeline Pipe OpStmt OpName Soup Scalar [ ] ( ) + - * / , = . ' : ! ? < > @ % & # ; ^ ` and else false if in let match meta not null or this true EmptyRecord { } RecordStart RecordRest PipeExpr String StringEsc AssignStmt UnExpr",
  maxTerm: 92,
  context: context,
  skippedNodes: [0,4,5,59],
  repeatNodeCount: 9,
  tokenData: "FgnR}OX$OXY%sY[$O[]%s]p$Opq%sqr)_rs)|st*]tu$Ouv*zvw+iwx,Wxy,uyz-dz{.R{|.p|}/_}!O/|!O!P0k!P!Q1Y!Q![5W![!]8u!]!^:V!^!_:t!_!`;c!`!a<Q!a!b<o!b!c=^!c!}$O!}#O={#O#P>j#P#QAQ#Q#RAo#R#S$O#S#TB^#T#f$O#f#gB{#g#o$O#o#pDf#p#qET#q#rEr#r;'S$O;'S;=`Fa<%lO$Ol$XU!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$k[$rU!zW!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kW%ZS!zWOr%Us;'S%U;'S;=`%g<%lO%UW%jP;=`<%l%U[%pP;=`<%l$kn&O[!zW!}`!jQ!wSOX$kXY&tY[$k[]&t]p$kpq&tqr$ks#O$k#O#P's#P;'S$k;'S;=`%m<%lO$k^&}[!zW!jQ!wSOX$kXY&tY[$k[]&t]p$kpq&tqr$ks#O$k#O#P's#P;'S$k;'S;=`%m<%lO$kY'xW!zWOY%UYZ(bZ]%U]^(b^r%Us;'S%U;'S;=`%g<%lO%UY(i[!zW!jQOX%UXY(bY[%U[](b]p%Upq(bqr%Us#O%U#O#P's#P;'S%U;'S;=`%g<%lO%Un)jUiQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn*TP!v^!}`st*W`*]O#O`n*hUpQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn+VUnQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn+tUoQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn,cUgQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn-QU^Q!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn-oU_Q!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn.^UbQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn.{U`Q!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn/jUdQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn0XUaQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn0vUfQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn1eY!zW!}`!wScQOr$ksz$kz{2T{!P$k!P!Q2p!Q#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$k^2^U!kQ!zW!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$k^2yZ!zW!wSSQOY2pYZ$kZ]2p]^$k^r2prs3ls#O2p#O#P4W#P;'S2p;'S;=`5Q<%lO2pQ3qTSQOY3lZ]3l^;'S3l;'S;=`4Q<%lO3lQ4TP;=`<%l3lY4_X!zWSQOY4WYZ%UZ]4W]^%U^r4Wrs3ls;'S4W;'S;=`4z<%lO4WY4}P;=`<%l4W^5TP;=`<%l2pn5c`ZQ!zW!}`!wSOr$ks!O$k!O!P6e!P!Q$k!Q![6e![!c$k!c!}7p!}#O$k#O#P%U#P#R$k#R#S6e#S#T$k#T#o7p#o;'S$k;'S;=`%m<%lO$k^6n`ZQ!zW!wSOr$ks!O$k!O!P6e!P!Q$k!Q![6e![!c$k!c!}7p!}#O$k#O#P%U#P#R$k#R#S6e#S#T$k#T#o7p#o;'S$k;'S;=`%m<%lO$k^7y^ZQ!zW!wSOr$ks!Q$k!Q![7p![!c$k!c!}7p!}#O$k#O#P%U#P#R$k#R#S7p#S#T$k#T#o7p#o;'S$k;'S;=`%m<%lO$kn9QWhQ!zW!}`!wSOr$ks![$k![!]9j!]#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$k^9sU!sQ!zW!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn:bUqQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn;PUkQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn;nUeQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn<]UlQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn<zUjQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn=iUmQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn>WU[Q!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn>qY!zW!}`OY?aYZ?tZ]?a]^?t^r?ars@ss;'S?a;'S;=`@x;=`<%l@s<%lO?a[?hS!YS!zWOr%Us;'S%U;'S;=`%g<%lO%U^?}[!YS!zW!jQOX%UXY(bY[%U[](b]p%Upq(bqr%Us#O%U#O#P's#P;'S%U;'S;=`%g<%lO%US@xO!YS[@}P!YS;=`<%l?anA]U]Q!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$knAzUrQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$knBiUsQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$knCUW!zW!}`!wSOr$krsCnstCst#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kQCsO!yQ^CzV!zW!wSOr$krsDas#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kQDfO!|QnDqU!SQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$knE`U!oQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$knE}U!TQ!zW!}`!wSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$klFdP;=`<%l$O",
  tokenizers: [1, 2, 3, 4, newlines, identifiers, new lr.LocalTokenGroup("b~RPz{U~XP!P!Q[~aO!m~~", 17, 74)],
  topRules: {"Pipeline":[0,6]},
  dynamicPrecedences: {"52":2,"57":1},
  specialized: [{term: 1, get: value => spec_Ident[value] || -1}],
  tokenPrec: 956
});

const punctuation = `"+" "-" "*" "/" "=" "." "'" ":" "!" "?" "<" ">" "@" "%" "&" "#" ";" "^" "\`"`;
const TenzirQueryLang = language.LRLanguage.define({
    languageData: {
        commentTokens: { line: "//", block: { open: "/*", close: "*/" } },
    },
    parser: parser.configure({
        props: [
            highlight.styleTags({
                "Scalar true false null DollarIdent": highlight.tags.literal,
                String: highlight.tags.string,
                "StringEsc and else if in let match meta not or this": highlight.tags.keyword,
                "OpName! FnIdent": highlight.tags.name,
                [punctuation]: highlight.tags.punctuation,
                "LineComment BlockComment": highlight.tags.comment,
            }),
        ],
        // TODO: add folding later
    }),
});
function TQL() {
    return new language.LanguageSupport(TenzirQueryLang);
}

exports.TQL = TQL;
exports.TenzirQueryLang = TenzirQueryLang;
